#include <stm32f10x.h>
#include "Delays.h"

//#define LCD_ENABLE_READ

#define LCD_GPIO GPIOB
#define RCC_LCD_GPIO RCC_APB2Periph_GPIOB
#define LCD_D4 GPIO_Pin_6
#define LCD_D5 GPIO_Pin_7
#define LCD_D6 GPIO_Pin_8
#define LCD_D7 GPIO_Pin_9

#define RS_GPIO GPIOB
#define RCC_LCD_RS_GPIO RCC_APB2Periph_GPIOB
#define LCD_RS GPIO_Pin_14

#define EN_GPIO GPIOB
#define RCC_LCD_EN_GPIO RCC_APB2Periph_GPIOB
#define LCD_EN GPIO_Pin_13

#define LIGHT_GPIO GPIOB
#define RCC_LCD_EN_GPIO RCC_APB2Periph_GPIOB
#define LCD_LIGHT GPIO_Pin_15

#define HD44780_CLEAR					   0x01

#define HD44780_HOME					      0x02

#define HD44780_ENTRY_MODE				   0x04
	#define HD44780_EM_SHIFT_CURSOR		0
	#define HD44780_EM_SHIFT_DISPLAY	   1
	#define HD44780_EM_DECREMENT		   0
	#define HD44780_EM_INCREMENT		   2

#define HD44780_DISPLAY_ONOFF			   0x08
	#define HD44780_DISPLAY_OFF		   	   0
	#define HD44780_DISPLAY_ON			   4
	#define HD44780_CURSOR_OFF			   0
	#define HD44780_CURSOR_ON			   0x0f
	#define HD44780_CURSOR_NOBLINK	   0
	#define HD44780_CURSOR_BLINK		   1

#define HD44780_DISPLAY_CURSOR_SHIFT	0x10
	#define HD44780_SHIFT_CURSOR		   0
	#define HD44780_SHIFT_DISPLAY		   8
	#define HD44780_SHIFT_LEFT			   0
	#define HD44780_SHIFT_RIGHT		   4

#define HD44780_FUNCTION_SET			   0x20
	#define HD44780_FONT5x7				   0
	#define HD44780_FONT5x10			   4
	#define HD44780_ONE_LINE			   0
	#define HD44780_TWO_LINE			   8
	#define HD44780_4_BIT				   0
	#define HD44780_8_BIT				   16

#define HD44780_CGRAM_SET				   0x40

#define HD44780_DDRAM_SET				   0x80

void LCD_Initialization(void);
void LCD_WriteData(u8);
void LCD_WriteCommand(u8);
void LCD_WriteText(char *);
void LCD_WriteTextXY(char * , u8 , u8);
void LCD_GoTo(unsigned char, unsigned char);
void LCD_WriteBinary(u32 var, u8 bitCount);
void LCD_ClearLine(int line);
#ifdef LCD_ENABLE_READ
u8 LCD_ReadNibble(void)
u8 LCD_ReadStatus(void)
#endif
